use std::error::Error;
use serde::Deserialize;


#[derive(Deserialize, Debug)]
pub struct BestResult {
    pub nick: String,
    pub result: u64
}

pub struct ApiController {
}


impl ApiController {
    pub fn post_result(nick: &str, points: &u64) -> Result<(), Box<dyn Error>> {
        let client = reqwest::blocking::Client::new();
        let url = format!("http://localhost:8000/user_data/?nick={}&timestamp={}&mode={}&result={}", nick, 123, 1, points);
        let _res = client.post(url)
            .send()?;
        Ok(())
    }

    pub fn get_best_user() -> Result<BestResult, Box<dyn Error>> {
        let url = "http://localhost:8000/best";
        let res: BestResult = reqwest::blocking::get(url)?
            .json()?;
        Ok(res)
    }

    pub fn get_user_best(nick: &String) -> Result<BestResult, Box<dyn Error>> {
        let url = format!("http://localhost:8000/best/{}", nick);
        let res: BestResult = reqwest::blocking::get(url)?
            .json()?;
        Ok(res)
    }
}